#!/bin/sh -Te
# Copyright (C)2019 @BABOLO http://www.babolo.ru/
#--PKG = mini-cipa
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: minicipa.m4,v 1.18 2019/09/09 16:29:27 babolo Exp $

CIPA=`/usr/bin/basename ${0}`
CIPA_CONF=CONFDIR/${CIPA}.conf
. ${CIPA_CONF}
pidfile="/var/run/${CIPA}.pid"

if  [ -r ${pidfile} ]; then
    pidd="`head -1 ${pidfile}`"
    if  [ -n "${pidd}" ]; then
        y=` /bin/ps -ax ${pidd}\
          | /usr/bin/awk '/bin/{$1 = "";\
                                $2 = "";\
                                $3 = "";\
                                $4 = "";\
                                if ($0 ~ /\/bin\/sh -T/) print "yes"\
                               }\
                         '\
          `
        if  [ "${y}" = "yes" ]; then
            kill -1 ${pidd} || :
            while [ -r ${pidfile} ]; do
                sleep 1
            done
fi; fi; fi

/bin/sh -T <<- EOF &
	mypid=\$\$
	echo "\${mypid}" > ${pidfile}
	date '+Start %F %T' >> ${pidfile}

	# --       HUP
	trap " kill -1 \\\` /bin/ps -axl						\
			  | /usr/bin/awk \"{if  (\\\\\\\\\\\\\\\$3 == \\\${mypid})	\
						print \\\\\\\\\\\\\\\$2}		\
					 \"						\
		       \\\`								\
	     ; /bin/rm -f ${pidfile}							\
	     ; kill -15 \\\${mypid}							\
	     " 1

	# -- endless loop
	while : ; do
	    if ! BINDIR/pgoblin "${0}" >> /var/log/MINICIPA.log 2>&1;  then
	        /usr/bin/logger -t ${CIPA} -p daemon.err "${CIPA} fails \`date '+%F %T'\`" || :
	    fi
	done
	/usr/bin/logger "${CIPA} stops"
EOF
exit

#!BINDIR/pgoblin
#echo      Q
##Q copy E
#style     00Q00Q
Q
#connect   0001
sqlite2
#connect   0002
pgsql dbname=MINICIPA requirepeer=postgres application_name=minicipa
#cat       E
/var/log/MINICIPA.log
#perform   0002
LISTEN cipaxn;
#begin     0002
#select    E002
SELECT 'Sleep from '
     , to_char(now(), 'YYYY-MM-DD HH24:MI:SS ')
     , 'to '
     , to_char( '1970-01-01'::timestamp + (floor(date_part('epoch', c)) * '1s'::interval)
              , 'YYYY-MM-DD HH24:MI:SS'
              )
     , '
'FROM(SELECT COALESCE( (SELECT cipaxn.plan
                         FROM public.cipaxn
                         WHERE ready
                        ORDER BY cipaxn.plan
                        LIMIT 1
                       ) + '1sec'
                     , now() + '1day'
                     ) AS c
     )c
;
#binpresel 2002
SELECT (floor(date_part('epoch', c)) * 1000000)::int8
 FROM(SELECT COALESCE( (SELECT cipaxn.plan
                         FROM public.cipaxn
                         WHERE ready
                        ORDER BY cipaxn.plan
                        LIMIT 1
                       ) + '1sec'
                     , now() + '1day'
                     ) AS c
     )c
;
#end       0002
#listen    0022
cipaxn
#select    E002
SELECT 'Wake on ', to_char(now(), 'YYYY-MM-DD HH24:MI:SS'), '
'
;
#perform   0002   -- ,   
SELECT *, array_upper(args, 1) AS argc
INTO TEMP t
 FROM(SELECT cipaxn.cipain                   AS cipain
           , cipalan.cipalan                 AS cipalan
           , now()                           AS t
           , cipalan.whom                    AS whom
           , cipalan.cipath || cipaxn.ciparg AS args
       FROM public.cipaxn JOIN public.cipalan USING(cipalan)
       WHERE ready AND plan < now()
      ORDER BY make_interval(0, 0, 0, 0, 0, 0, cipaxn.prio) * (cipaxn.try + 1) + cipaxn.plan
      LIMIT 1
     )z
;
#select    1002
SELECT '#exit
'WHERE (SELECT COUNT(1) FROM t) = 0
;
#eval      01     --   
#echo      D
##D pgo0 UD
## +H0
SELECT 
## +U0
'BINDIR/su2', 
## +D0
, '--', 
## +U
args[
## -D
], 
## -D0
] 
## -H0
FROM t;


#style     00D00D
D
#select    t002
SELECT t.cipain, t.t FROM t;
#select    T0t1
SELECT ?, ?;
#select    F0t1
SELECT ? WHERE ? IS NOT NULL;
#perform   00F2
UPDATE cipain SET try = try + 1 WHERE cipain = $1::int;
#select    E002   --   stderr
SELECT 'Start '
     , t.cipalan
     , '.'
     , t.cipain
     , ' '
     , to_char(t.t, 'YYYY-MM-DD HH24:MI:SS ')
     , t.args
     , '
'FROM t
;
#select    1002   --     exec
WITH s AS(SELECT NULL      AS h
               , 'SELECT ' AS u
               , -1 AS n
         UNION
          SELECT NULL AS h
               , '''BINDIR/su2'', ' || quote_literal(t.whom) || ', ''--'', ' AS u
               , 0 AS n
           FROM t
           WHERE COALESCE(t.whom <> 'root', FALSE)
         UNION
          SELECT ','
               , ' args[' || i || ']'
               , i
           FROM t, generate_series(1, t.argc) AS i
           WHERE t.args[i] IS NOT NULL
         UNION
          SELECT ' FROM t', NULL, t.argc + 1
           FROM t
         )
   , n AS(SELECT MIN(n) AS m FROM s WHERE n > 0)
SELECT CASE WHEN s.n <> n.m THEN s.h END
     , s.u
 FROM s, n
ORDER BY s.n
;
# select    1002   --     exec
SELECT s.u
 FROM(SELECT CASE WHEN COALESCE(t.whom <> 'root', FALSE) THEN quote_literal(t.whom) END AS u
           , 0 AS n
       FROM t
     UNION
      SELECT i::text AS u, i AS n
       FROM t, generate_series(1, t.argc) AS i
     )s
ORDER BY s.n
;
# display   20100D   --    
#echo      21
#select    3202
#fork      404    --    .    .
#close     E0E    #####################################################################################
#cat       E
/var/log/MINICIPA.log
#cat       N
/dev/null
#job       00001
local -Z
#connect   0004
sqlite2
#connect   0003
pgsql dbname=MINICIPA requirepeer=postgres application_name=minicipa
#perform   0004
CREATE TEMP TABLE j(i int4, n int4, c int4, s int4);
#exec      E3N01  -- 1        
#getjob    50001  --     ,   
#copyin    0054
COPY j FROM stdin;
#select    1004
SELECT '#exit
7
'WHERE (SELECT COUNT(1) FROM j) = 0
;
#eval      01     --   
#select    1004
SELECT '#exit
8
'WHERE (SELECT COUNT(1) FROM j) <> 1
;
#eval      01     --   
#perform   00T3
SELECT cipaxn.cipain                   AS cipain
     , cipalan.cipalan                 AS cipalan
     , $2::timestamp                   AS t
     , cipalan.cipath || cipaxn.ciparg AS args
INTO TEMP f
 FROM public.cipaxn JOIN public.cipalan USING(cipalan)
 WHERE cipaxn.cipain = $1
;
#select    R0T4
SELECT ?, ?, j.c FROM j;
#perform   00R3
UPDATE public.cipain SET deed = $2::timestamp, pid = $3::int WHERE cipain.cipain = $1;
#close     404    --          
#wait      00001  -- ,     
#perform   0004
DELETE FROM j;
#getjob    50001  --     
#copyin    0054
COPY j FROM stdin;
#select    R0F4
SELECT ?, (j.s >> 8) & 255 FROM j;
#perform   00R3   --      
DELETE FROM public.cipaxn
 USING public.cipalan
 WHERE cipaxn.cipalan = cipalan.cipalan
   AND cipaxn.cipain = $1::int
   AND (  $2::int = 0
       OR NOT cipalan.success
       )
;
#perform   00F3
UPDATE cipain SET pid = NULL WHERE cipain.cipain = $1::int;
#select    R0F4
SELECT ?, (j.s >> 8) & 255, j.c FROM j;
#select    E0R3   --   stderr
SELECT 'Exit '
     , $2
     , ' '
     , f.cipalan
     , '.'
     , $1
     , ' '
     , $3
     , ' '
     , to_char(now(), 'YYYY-MM-DD HH24:MI:SS ')
     , f.args
     , '
'FROM f
;
#exit      0003   #####################################################################################
#cat       N      --    
/dev/null
#getstr    N04    -- ,    
#return    0002
